#ifndef _MAP_H
#define _MAP_H

#include "mnstruct.h"
#include "misc.h"
#include "obstruct.h"

/* tile types */
#define WALL 0
#define FLOOR 1
#define DOOR 2
#define BROKEN_DOOR 3
#define STAIRWAY_UP 4
#define STAIRWAY_DOWN 5

/* .special.closed */
#define OPEN 0
#define CLOSED 1
#define LOCKED 2

typedef struct
{ char type;
  union
  { char closed;
    int destination;
  } special;
  char memory;
  int scent;
  obj *items;
} block;

typedef struct
{ block **place;
  char **lastseen;
  monster *mhead;
  int xsize;
  int ysize;
} map;

void fillmap(int nobjs, int nmonsts);
void changelevel(int n, int up, int down, int where);
coord findfreespace();
int walkable(coord c);
extern map *m;

extern coord diradd[4];

#define here(x, y) (m->place[(x)][(y)].type)
#define special(x, y) (m->place[(x)][(y)].special)

#endif
