#include <stdarg.h>
#include <stdio.h>
#include <string.h>
#include "colors.h"
#include "io.h"
#include "messages.h"
#include "misc.h"
#include "player.h"
#include "vision.h"

static void pmessage(char *pre, char *string);

#define DECL_PLINE(fname, string) \
  void fname(char *fmt, ...)      \
  { va_list args;                 \
    static char s[BUFSZ];         \
                                  \
    va_start(args, fmt);          \
    vsprintf(s, fmt, args);       \
    va_end(args);                 \
                                  \
    pmessage(string, s);          \
  }

DECL_PLINE(pline, "")
DECL_PLINE(You, "You ")

static int tl_cursor=-1;
static char *more="-- more --";
static char *pressakey="-- press a key --";

#define PM_BUFFER_SIZE (SCREEN_HEIGHT-2)

static char pm_buffer[PM_BUFFER_SIZE][SCREEN_WIDTH+1];
static int pm_cursor;

static void pmessage(char *pre, char *message)
{ static char s[BUFSZ];

  strcpy(s, pre);
  strcat(s, message);

  if(tl_cursor+strlen(s)>SCREEN_WIDTH-2-strlen(more))
  { putstring(tl_cursor+1, 0, more);
    updatescreen();
    placecursor(tl_cursor+strlen(more)+1, 0);
    while(readchar()!=' ');
    cleartopline();
  }

  strcat(pm_buffer[pm_cursor], s);
  strcat(pm_buffer[pm_cursor], " ");

  putstring(tl_cursor+1, 0, s);
  tl_cursor+=strlen(s)+1;
  updatescreen();
  placecursor(tl_cursor, 0);
}

static int list_cursor=0;

void print_list(char *fmt, ...)
{ int i;

  va_list args;
  static char s[BUFSZ];

  va_start(args, fmt);
  vsprintf(s, fmt, args);
  va_end(args);

  if(list_cursor==SCREEN_HEIGHT-2)
  { putstring(1, list_cursor, pressakey);
    updatescreen();
    placecursor(strlen(pressakey)+1, list_cursor);
    readchar();
    for(i=0; i<80; i++) screen[i][0][0]=' ';
    updatedisplay();
    list_cursor=0;
  }
  else
  { putstring(1, list_cursor++, s);
    updatescreen();
  }
}

void end_list()
{ int i;

  putstring(1, list_cursor, pressakey);
  updatescreen();
  placecursor(strlen(pressakey)+1, list_cursor);
  readchar();
  for(i=0; i<80; i++) screen[i][0][0]=' ';
  updatedisplay();
  list_cursor=0;
}

void putstring(int x, int y, char *s)
{ while(*s)
  { screen[x][y][0]=*s++;
    screen[x++][y][1]=LIGHTGREY;
  }
  screen[x][y][0]=' ';
  screen[x][y][1]=LIGHTGREY;
}

void cleartopline()
{ int i;

  if(*pm_buffer[pm_cursor])
  { pm_cursor=(pm_cursor+1)%PM_BUFFER_SIZE;
    *pm_buffer[pm_cursor]=0;
  }

  for(i=SCREEN_WIDTH-1; i>=0; i--) screen[i][0][0]=' ';
  tl_cursor=-1;
}

char prompt(char *fmt, ...)
{ va_list args;
  static char s[BUFSZ];
  char c;

  va_start(args, fmt);
  vsprintf(s, fmt, args);
  va_end(args);

  cleartopline();
  pline(s);
  c=readchar();
  cleartopline();

  return c;
}

void bottomline()
{ static char s[BUFSZ];
  int i;

  sprintf(s, "HP: %d(%d) Str:%d Dex:%d(%d) Int:%d PV:%d",
             you.hp, you.maxhp, you.strength, you.dexterity, you.maxdexterity,
             you.intelligence, you.protection);

  for(i=0; i<SCREEN_WIDTH; i++)
    screen[i][SCREEN_HEIGHT-2][0]=screen[i][SCREEN_HEIGHT-1][0]=' ';
  putstring(0, SCREEN_HEIGHT-2, s);
}

void showpastmessages()
{ int i;

  print_list("Past messages:");
  for(i=pm_cursor+1; i!=pm_cursor; i=(i+1)%PM_BUFFER_SIZE)
    if(pm_buffer[i][0])
      print_list(pm_buffer[i]);
  end_list();
}
