#include <assert.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include "misc.h"

#define DEBUG

#ifdef DEBUG
static int total;
#endif

void *zmalloc(int size)
{ void *p;

  assert(p=malloc(size));
  memset(p, 0, size);

#ifdef DEBUG
  printf("zmalloc %d (%d)\n", size, total+=size);
#endif

  return p;
}

void *zcalloc(int count, int size)
{ void *p;

  assert(p=malloc(count*size));
  memset(p, 0, count*size);

#ifdef DEBUG
  printf("zcalloc %d*%d=%d (%d)\n", count, size,
                                    count*size, total+=count*size);
#endif

  return p;
}

void zfree(void *p)
{ free(p);
}

int randint(int max)
{ return rand()%max;
}

void seedrandom()
{ srand(time(0));
}

int roll(die d)
{ int i, n=d.offset;

  for(i=0; i<d.count; i++) n+=randint(d.sides)+1;

  return n;
}

/* whee.  too clever for my own good. */
int sgn(int x)
{ if(x<0) return -1;
  return x && 1;
}

/* believe it or not, this is the pythagorean theorem for roguelikes */
int distance(coord start, coord dest)
{ if(abs(start.x-dest.x)>abs(start.y-dest.y)) return abs(start.x-dest.x);
  else return abs(start.y-dest.y);
}
